

/* Magician Chassis Bluebots Bluetooth
   Hobbytronics ltd, 2012
   
*/

#define baudRate 38400

// Setup pins for SN754410 Motor chip

// motor port mapping
#define PWM_PIN_A 9
#define THISWAY_PIN_A 7
#define THATWAY_PIN_A 8
#define PWM_PIN_B 10
#define THISWAY_PIN_B 5
#define THATWAY_PIN_B 6


int left = 0; 
int right = 0; 

unsigned char data_packet[4];
unsigned char packet_index=0;

void setup()  { 
  
  // use the baud rate your bluetooth module is configured to 
  Serial.begin(baudRate); 
  
  // set pin mode for motor
     pinMode(PWM_PIN_A, OUTPUT);
     pinMode(THISWAY_PIN_A, OUTPUT);
     pinMode(THATWAY_PIN_A, OUTPUT);
     pinMode(PWM_PIN_B, OUTPUT);
     pinMode(THISWAY_PIN_B, OUTPUT);
     pinMode(THATWAY_PIN_B, OUTPUT);

    
} 

void loop()  { 
  
  // check if data has been sent from the computer:
  if (Serial.available()) {
    // read the most recent byte:
    data_packet[packet_index] = Serial.read();
    packet_index++;
    if(packet_index==4)
    {
      // full packet received
      process_packet();
    }  
  }
  setMotors();
}

void process_packet()
{
  int lspeed, lturn;
  
  packet_index=0;
  if((data_packet[0]==43) || (data_packet[0]==45))
  {
    if(data_packet[0]==43) lturn=data_packet[1];
    else lturn=data_packet[1]*-1;

    if(data_packet[2]==43) lspeed=data_packet[3]*2;
    else lspeed=data_packet[3]*-2;    
    
    left=(lspeed+lturn);
    left = constrain(left, -255, 255);
    right=(lspeed-lturn);
    right = constrain(right, -255, 255);    
      
  }  
 
}

void setMotors()
{
   int vLeft = left;
   int vRight = right;
   if (vLeft < 0)
   {
            analogWrite(PWM_PIN_A, abs(vLeft));
            digitalWrite(THISWAY_PIN_A, 0);
            digitalWrite(THATWAY_PIN_A, 1);  
//        analogWrite(lf, 0);         
//        analogWrite(lr, abs(vLeft)); 
   }
   else{
            analogWrite(PWM_PIN_A, abs(vLeft));
            digitalWrite(THISWAY_PIN_A, 1);
            digitalWrite(THATWAY_PIN_A, 0);  
//        analogWrite(lf, abs(vLeft));         
//        analogWrite(lr, 0);      
   }
   
   if (vRight < 0)
   {
            analogWrite(PWM_PIN_B, abs(vRight));
            digitalWrite(THISWAY_PIN_B, 0);
            digitalWrite(THATWAY_PIN_B, 1);  
//        analogWrite(rf, 0);         
//        analogWrite(rr, abs(vRight)); 
   }
   else{
            analogWrite(PWM_PIN_B, abs(vRight));
            digitalWrite(THISWAY_PIN_B, 1);
            digitalWrite(THATWAY_PIN_B, 0);  
//        analogWrite(rf, abs(vRight));         
//        analogWrite(rr, 0);      
   }          

  
}


